From 89c060ae8bdd843216cd532d8be0889c7ae5f1b5 Mon Sep 17 00:00:00 2001
From: Sebastian Poeplau <sebastian.poeplau@eurecom.fr>
Date: Tue, 25 Jun 2019 11:37:06 +0200
Subject: [PATCH] Replace anonymous mmap with malloc and mprotect

This is easier to support in KLEE.
---
 include/libcgc.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

diff --git a/include/libcgc.c b/include/libcgc.c
index 293fb608..dca7e660 100644
--- a/include/libcgc.c
+++ b/include/libcgc.c
@@ -155,12 +155,16 @@ int cgc_allocate(cgc_size_t length, int is_executable, void **addr) {
   if (is_executable)
     page_perms |= PROT_EXEC;
 
-  void *return_address = mmap(NULL, length, page_perms, MAP_ANONYMOUS | MAP_PRIVATE, 0, 0);
+  /* void *return_address = mmap(NULL, length, page_perms, MAP_ANONYMOUS | MAP_PRIVATE, 0, 0); */
+  void *return_address = malloc(length);
 
-  if (return_address == MAP_FAILED) {
+  /* if (return_address == MAP_FAILED) { */
+  if (return_address == NULL) {
     return errno;
   }
 
+  mprotect(return_address, length, page_perms);
+
   if (addr)
     *addr = return_address;
 
-- 
2.23.0

